ru.yandex.clickhouse.util

## Class ClickHouseBitmap

- java.lang.Object
- - ru.yandex.clickhouse.util.ClickHouseBitmap

    public abstract class ClickHouseBitmap
    extends Object

### Field Summary

Fields
`protected int` `byteLen`
`protected ClickHouseDataType` `innerType`
`protected Object` `reference`

### Constructor Summary

Constructors
`protected` `ClickHouseBitmap(Object bitmap, ClickHouseDataType innerType)`

### Method Summary

All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
`static ClickHouseBitmap` `deserialize(byte[] bytes, ClickHouseDataType innerType)`
`static ClickHouseBitmap` `deserialize(DataInputStream in, ClickHouseDataType innerType)`
`boolean` `equals(Object obj)`
`abstract int` `getCardinality()`
`long` `getLongCardinality()`
`int` `hashCode()`
`abstract void` `serialize(ByteBuffer buffer)`
`abstract int` `serializedSizeInBytes()`
`long` `serializedSizeInBytesAsLong()`
`String` `toBitmapBuildExpression()`
`ByteBuffer` `toByteBuffer()` Serialize the bitmap into a flipped ByteBuffer.
`byte[]` `toBytes()`
`abstract int[]` `toIntArray()`
`long[]` `toLongArray()`
`Object` `unwrap()`
`static ClickHouseBitmap` `wrap(byte... values)`
`static ClickHouseBitmap` `wrap(int... values)`
`static ClickHouseBitmap` `wrap(long... values)`
`static ClickHouseBitmap` `wrap(Object bitmap, ClickHouseDataType innerType)`
`static ClickHouseBitmap` `wrap(short... values)`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### innerType

    protected final ClickHouseDataType innerType

#### byteLen

    protected final int byteLen

#### reference

    protected final Object reference

### Constructor Detail

#### ClickHouseBitmap

    protected ClickHouseBitmap(Object bitmap,
                               ClickHouseDataType innerType)

### Method Detail

#### wrap

    public static ClickHouseBitmap wrap(byte... values)

#### wrap

    public static ClickHouseBitmap wrap(short... values)

#### wrap

    public static ClickHouseBitmap wrap(int... values)

#### wrap

    public static ClickHouseBitmap wrap(long... values)

#### wrap

    public static ClickHouseBitmap wrap(Object bitmap,
                                        ClickHouseDataType innerType)

#### deserialize

    public static ClickHouseBitmap deserialize(DataInputStream in,
                                               ClickHouseDataType innerType)
                                        throws IOException

Throws:
  `IOException`

#### deserialize

    public static ClickHouseBitmap deserialize(byte[] bytes,
                                               ClickHouseDataType innerType)
                                        throws IOException

Throws:
  `IOException`

#### getCardinality

    public abstract int getCardinality()

#### getLongCardinality

    public long getLongCardinality()

#### serialize

    public abstract void serialize(ByteBuffer buffer)

#### serializedSizeInBytes

    public abstract int serializedSizeInBytes()

#### serializedSizeInBytesAsLong

    public long serializedSizeInBytesAsLong()

#### toIntArray

    public abstract int[] toIntArray()

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### toLongArray

    public long[] toLongArray()

#### toByteBuffer

    public ByteBuffer toByteBuffer()

Serialize the bitmap into a flipped ByteBuffer.

Returns:
  flipped byte buffer

#### toBytes

    public byte[] toBytes()

#### toBitmapBuildExpression

    public String toBitmapBuildExpression()

#### unwrap

    public Object unwrap()